'
' -------------------------------------------------------------
' SORT OUT THE VARIOUS RAPIDQ LIBRARY GROUPS     Version  1.0.1
' February 13th, 2005                     by   Jacques Philippe
'
' Just run it and point it to your RapidQ Libraries'Directories
' If you have an Unknown Group of interest please COPY the interesting
' part of file "KnownLibs.Slst" and past it in the RapidQ Yahoo
' Group.
' I dont pretend that my GroupNames are the Good Ones. Drop a message
' in the Group if you have comments about these Libraries GroupNames
'
' I'll try to do the same thing for DE_UPX_ED Libraries ... Maybe !
' -------------------------------------------------------------
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
$INCLUDE "QInputBox.Inc"
Dim myInput As QInputBox
'
Declare Function CheckKnownLib (iHash As Integer) As Long
Declare Function GetLibDir () As String
Declare Sub ScanDirForLibs
'
' Hash Function             see  WARNING.TXT
$Include "Hash32Bit.Inc"
'
' List of RQ Libs FileNames
Dim slLibNames As QStringList
slLibNames.Additems "RapidQ2.Lib", "RapidQ2c.Lib", "RapidQ3.Lib", "RapidQ3c.Lib", "RapidQ4.Lib", "RapidQ4c.Lib", _
        "RapidQcc.Lib", "RapidQ32.Lib", "RapidQCC.Dll", "RapidQ32.Dll"
'
' List of Known Group Libraries
Dim slKnownLibs As QStringList  ' Format .item(N) = Hex$(HashValue) & "*" & LibName & "*" & LibGroupName
'
' List of text output to save output to file
Dim slText As QStringList
' INITIALISATION
' --------------
DefStr sGroupName = "", sNewGroupName = ""
' Get slKnownLibs from file
If FileExists ("KnownLibs.Slst") <> 0 Then
    slKnownLibs.LoadFromFile ("KnownLibs.Slst")
Else      ' create empty if dont exist
    slKnownLibs.Clear
    slKnownLibs.SaveToFile ("KnownLibs.Slst")
End If
DefStr sInitDir = "C:\\Rapid-Q\\Libs"
DefInt flagChangeInitDir = 1
' RQ Libs Directory
' -----------------
DefStr sLibDir
$Include "QBrowseDialog.Inc"
Dim myBrowserDir AS QBrowseDialog
'
' Scan Directory for Known or new Libraries
' -----------------------------------------
Do
    sLibDir = GetLibDir
    If sLibDir <> "" Then
        Print ("\n___NEW DIR___: " & sLibDir)
        slText.AddItems ("\n___NEW DIR___: " & sLibDir)
        ScanDirForLibs
        slKnownLibs.SaveToFile ("KnownLibs.Slst")
    End If
    If MessageDlg("WOULD YOU LIKE TO SCAN ANOTHER DIRECTORY ?", mtInformation, mbOK OR mbCancel, 0) = IdCancel Then
        Exit Do
    End If
    sNewGroupName = ""
Loop Until (1 + 1 = 3)  ' :)
' Save the Output Screen
DefStr sSavedScreen = "TextOut_" & ((Date$ - "-") -"/") & "_" & (Time$ - ":") & ".Txt"
Print "\nCONTENT OF THIS SCREEN SAVED AS  \"";sSavedScreen;"\""
slText.SaveToFile (sSavedScreen)
'
' -------------------------------------------------------------
' EXIT CONSOLE
' ------------
DefStr sExit
Input "\n                    CR to QUIT", sExit
Application.Terminate
End
' ---- SUBs and FUNCTIONs -------------------------------------
Function GetLibDir () As String
    DefStr sTmp
    With myBrowserDir
        .Caption = "RapidQ DLL/LIB Version Tool"
        .Title = "SELECT A DIRECTORY TO SCAN FOR RQ LIBRARIES"
        .InitialDir = sInitDir
        If .Execute = True Then
            sTmp = .Directory
            Result = sTmp & "\\"
        Else
            ShowMessage ("  *** ERROR : CANT EXECUTE QBROWSEDIALOG")
            Result = ""
        End If
    End With
    If (flagChangeInitDir = 1 and Ucase$(sTmp) <> Ucase$(sInitDir)) Then
        If Tally(sTmp, "\\") > 1 Then sInitDir = Left$(sTmp, RInstr(sTmp, "\\") - 1)
    End If
    flagChangeInitDir = 0
End Function
' -------------------------------------------------------------
Function CheckKnownLib (iHash As Integer) As Long
    DefInt N
    DefStr sHash = Hex$(iHash)
    For N = 0 To slKnownLibs.ItemCount - 1
        If sHash = Field$(slKnownLibs.Item(N), "*", 1) Then
            sGroupName = Field$(slKnownLibs.Item(N), "*", 3)
            Result = N
            Exit function
        End If
    Next N
    If sNewGroupName = "" Then
        sNewGroupName = myInput.Show ("LIBRARY NOT KNOWN YET\n\nENTER A GROUP NAME FOR THESES LIBS", "RQ KNOWN LIBS GROUPS",      "IE : GROUP NAME + YOUR RQ NAME")
    End If
    Result = -1
End Function
' -------------------------------------------------------------
Sub ScanDirForLibs
    Dim fileLib As QFileStream
    DefStr sFileName, sStrFile, sTmp
    DefInt N, iHash, iKnown
    N = 0
    While N < slLibNames.ItemCount
        If fileLib.Open (sLibDir & slLibNames.Item(N), fmOpenRead) <> 0 Then
            ' NOT UN_UPX LIBS = .LIB and lenFile < 350000
            If (fileLib.Size < 350000 Or Right$(Ucase$(slLibNames.Item(N)), 4) = ".DLL") Then
                sStrFile = fileLib.ReadBinStr (fileLib.Size)  ' read file in sStrFile
                iHash = Hash32Bit (sStrFile)                  ' compute Hash value for file
                iKnown = CheckKnownLib (iHash)                ' check if Lib is from a known group
                If iKnown = -1 Then
                    slKnownLibs.AddItems (Hex$(iHash) & "*" & slLibNames.Item(N) & "*" & sNewGroupName)
                    sTmp = "NEW   LIB: \"" & slLibNames.Item(N) & "\""
                    sTmp = sTmp & Space$ (35 - Len(sTmp))
                    sTmp = sTmp & "  Group Name: \"" & sNewGroupName & "\""
                    Print sTmp
                    slText.AddItems sTmp
                Else
                    sTmp = "KNOWN LIB: \"" & slLibNames.Item(N) & "\""
                    sTmp = sTmp & Space$ (35 - Len(sTmp))
                    sTmp = sTmp & "  Group Name: \"" & sGroupName & "\""
                    Print sTmp
                    slText.AddItems sTmp
                End If
            Else
                 sTmp = " *** SIZE > 350000 Bytes  \"" & slLibNames.Item(N) & "\""
                sTmp = sTmp & Space$ (35 - Len(sTmp)) & "  in   \"" & sLibDir & "\""
                Print sTmp
                slText.AddItems sTmp              
            End If
        Else
            sTmp = " *** CANT FIND \"" & slLibNames.Item(N) & "\""
            sTmp = sTmp & Space$ (35 - Len(sTmp)) & "  in   \"" & sLibDir & "\""
            Print sTmp
            slText.AddItems sTmp
        End If
        Inc N
    Wend
End Sub
' -------------------------------------------------------------
'
  